
// display
#include "Adafruit_GFX.h"
#include "Adafruit_GC9A01A.h"
#include "colors.h"
//#include <SPI.h>
//#include <Wire.h>

#define TFT1_DC 16
#define TFT1_CS 4
#define TFT2_DC 15
#define TFT2_CS 2
//SCL  -->  18
//SDA  -->  23

// Hardware SPI
Adafruit_GC9A01A tft1(TFT1_CS, TFT1_DC);
Adafruit_GC9A01A tft2(TFT2_CS, TFT2_DC);

// RTC clock
//#include <RTClib.h>
//RTC_DS3231 rtc;   // SCL -->22    SDA -->21


int startx = 120, starty = 120; //center of display
int x, y, minute, hour, hcounter;
double m; double h;
double color;

void setup() {
  Serial.begin(115200);
  delay(2000);
 
  // display setup
  tft1.begin();  tft2.begin();
  tft1.setRotation(2); tft2.setRotation(2);
  tft1.fillScreen(COLOR0); tft2.fillScreen(GC9A01A_BLACK);

/*
  // setup RTC module
  if (! rtc.begin()) {
    Serial.println("Can't find RTC");
    Serial.flush();
    while (1);
  }
  rtc.adjust(DateTime(F(__DATE__), F(__TIME__)));
  */
}
 
void loop() {
 /* 
  // get time
  DateTime now = rtc.now();
  Serial.print(now.hour(), DEC); Serial.print(':');
  Serial.print(now.minute(), DEC); Serial.print(':');
  Serial.println(now.second(), DEC);
  
  minute = now.minute();
  hour = now.hour();
Serial.print(hour);Serial.print(" : ");Serial.println(minute);

  */
  //tft1.fillScreen(COLOR03);  //test

 for(int i = 0; i<24; i++) {
  hour=i;
  hours();
  for (int j=0; j<60; j++){
    minute = j;
    minutes();
  }
 }
 delay(700);
}


void hours() {
  //tft1.fillScreen(GC9A01A_BLACK);


 //decide the color
  if (hour<12) {
    color = COLOR03;      //a.m.
    if (h==0){
      tft1.drawLine(startx, starty, 120, 0, COLOR03);
    }
  }
  if (hour>=12) {
      color = COLOR011;           //p.m.
      if (h==0){
       tft1.drawLine(startx, starty, 120, 0, COLOR11);
      }
      hour = hour-12;
  }

  h = (hour*30);    //1 hour --> 30°

    if (h<90){
      x= tan(radians(h)) *120;
      tft1.fillTriangle(startx, starty, 120, 0, x+120, 0, color);
    }
    if ((h>=90) && (h<180)){
      y= tan(radians(h-90)) *120;
      tft1.fillTriangle(startx, starty, 240, 120, 240, y+120, color); //actual quadrant
      tft1.fillRect(119, 0, 240, 120, color);                         //fill recent quadrant(s)
    }
    if ((h>=180) && (h<270)){
      x= tan(radians(h-180)) *120;
      tft1.fillTriangle(startx, starty, 120, 240, 120-x, 240, color); //actual quadrant
      tft1.fillRect(119, 0, 240, 240, color);                         //fill recent quadrant(s)
    }
    if ((h>=270) && (h<360)){
      y= tan(radians(h-270)) *120;
      tft1.fillTriangle(startx, starty, 0, 120, 0, 120-y, color);  //actual quadrant
      tft1.fillRect(119, 0, 240, 240, color);                      //fill recent quadrant(s)
      tft1.fillRect(0, 120, 120, 240, color);
    }
    if ((h==360) || (h==0)){
      tft1.fillScreen(COLOR0);
    }
}


void minutes() {
  m = (minute*6);  //1 hour --> 6°

     //decide the color
      double color;
      if (m>0) color = COLOR1;
      if (m>30) color = COLOR2;
      if (m>60) color = COLOR3;
      if (m>90) color = COLOR4;
      if (m>120) color = COLOR5;
      if (m>150) color = COLOR6;
      if (m>180) color = COLOR7;
      if (m>210) color = COLOR8;
      if (m>240) color = COLOR9;
      if (m>270) color = COLOR10;
      if (m>300) color = COLOR11;
      if (m>330) color = COLOR12;

    // draw minutes 
    if (m<=90){
      x= tan(radians(m)) *120;
      tft2.fillTriangle(startx, starty, 120, 0, x+120, 0, color);
    }
    if ((m>90) && (m<=180)){
      y= tan(radians(m-90)) *120;
      tft2.fillTriangle(startx, starty, 240, 120, 240, y+120, color);
      tft2.fillRect(119, 0, 240, 120, color);
    }
    if ((m>180) && (m<=270)){
      x= tan(radians(m-180)) *120;
      tft2.fillTriangle(startx, starty, 120, 240, 120-x, 240, color);
      tft2.fillRect(119, 0, 240, 240, color);
    }
    if ((m>270) && (m<=360)){
      y= tan(radians(m-270)) *120;
      tft2.fillTriangle(startx, starty, 0, 120, 0, 120-y, color);
      tft2.fillRect(119, 0, 240, 240, color);
      tft2.fillRect(0, 120, 120, 240, color);
    }
    if ((m==0) ||(m==360)){
      tft2.fillScreen(COLOR00);
    }
    delay(20);
}


 
/*
int           n, i, i2,
                cx = tft1.width()  / 2 - 1,
                cy = tft1.height() / 2 - 1;
  tft1.drawLine(x1, y1, x2, y2, color);
  tft1.fillScreen(GC9A01A_BLACK);
  tft1.drawFastHLine(0, y, w, color1);
  tft1.drawFastVLine(x, 0, h, color2);
  tft1.drawRect(cx-i2, cy-i2, i, i, color);
  tft1.fillRect(cx-i2, cy-i2, i, i, color1);
  tft1.drawRect(cx-i2, cy-i2, i, i, color2);
  tft1.fillCircle(x, y, radius, color);
  tft1.drawCircle(x, y, radius, color);
  tft1.drawTriangle(
      cx    , cy - i, // peak
      cx - i, cy + i, // bottom left
      cx + i, cy + i, // bottom right
      tft1.color565(i, i, i));
  tft1.fillTriangle(cx, cy - i, cx - i, cy + i, cx + i, cy + i,
      tft1.color565(0, i*10, i*10));
    t += micros() - start;
  tft1.drawTriangle(cx, cy - i, cx - i, cy + i, cx + i, cy + i,
      tft1.color565(i*10, i*10, 0));
  tft1.drawRoundRect(cx-i2, cy-i2, i, i, i/8, tft1.color565(i, 0, 0));
  tft1.fillRoundRect(cx-i2, cy-i2, i, i, i/8, tft1.color565(0, i, 0));
  tft1.setTextColor(GC9A01A_RED);    
  tft1.setTextSize(3);
  tft1.println("Text");
  tft1.setRotation(rotation);   //1-4
  tft1.fillArc(0,0, 140,0, 0, hourangle, color);
 */


 /*
 // Old color definitions
GC9A01A_BLACK 0x0000       ///<   0,   0,   0
GC9A01A_WHITE 0xFFFF       ///< 255, 255, 255
GC9A01A_LIGHTGREY 0xC618   ///< 198, 195, 198
GC9A01A_DARKGREY 0x7BEF    ///< 123, 125, 123
GC9A01A_PINK 0xFC18        ///< 255, 130, 198
GC9A01A_PURPLE 0x780F      ///< 123,   0, 123
GC9A01A_MAGENTA 0xF81F     ///< 255,   0, 255
*/

 